#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <mmsystem.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#pragma comment(lib, "winmm.lib")

struct SInfo
{
	PROCESS_INFORMATION m_info;
	int m_limit;
	int m_counter;
};

char g_tableThreadState[11][10];

void CALLBACK procedure_timer(UINT id, UINT, DWORD userdefine, DWORD, DWORD);
void mkCommandline(char *pBuffer, int argc, char *argv[]);
void mkTableThreadState();

// 0: this, 1: %, 2: process, 3.. args
int main(int argc, char *argv[])
{
	SInfo info;
	STARTUPINFO infoStartup;
	UINT idTimer;
	char aBuffer[4096];


	mkCommandline(aBuffer, argc, argv);
	mkTableThreadState();

	info.m_limit = atoi(argv[1])/10;
	if (info.m_limit <= 0)
		info.m_limit = 10;
	else if (10 < info.m_limit)
		info.m_limit = 10;

	info.m_counter = 0;

	ZeroMemory(&infoStartup, sizeof STARTUPINFO);
	infoStartup.cb = sizeof STARTUPINFO;
	CreateProcess(NULL, aBuffer, NULL, NULL, FALSE, CREATE_DEFAULT_ERROR_MODE| CREATE_NEW_PROCESS_GROUP| DETACHED_PROCESS, NULL, NULL, &infoStartup, &info.m_info);

	timeBeginPeriod(1);
	idTimer = timeSetEvent(10, 1, procedure_timer, (DWORD)&info, TIME_PERIODIC| TIME_CALLBACK_FUNCTION);

	WaitForSingleObject(info.m_info.hProcess, INFINITE);
	CloseHandle(info.m_info.hThread);
	CloseHandle(info.m_info.hProcess);
	timeKillEvent(idTimer);
	timeEndPeriod(1);

	return 0;
}

void mkCommandline(char *pBuffer, int argc, char *argv[])
{
	int i;


	pBuffer[0] = '\0';
	for (i=2; i<argc; i++)
	{
		if (2 != i)
			strcat(pBuffer, " ");
		if (NULL == strchr(argv[i], ' '))
			strcat(pBuffer, argv[i]);
		else
		{
			strcat(pBuffer, "\"");
			strcat(pBuffer, argv[i]);
			strcat(pBuffer, "\"");
		}
	}
}

void mkTableThreadState()
{
	int i;


	ZeroMemory(g_tableThreadState, sizeof g_tableThreadState);
	for (i=1; i<10; i++)
	{
		g_tableThreadState[i][0] = 1;
		g_tableThreadState[i][i] = -1;
	}
}

void CALLBACK procedure_timer(UINT id, UINT, DWORD userdefine, DWORD, DWORD)
{
	SInfo *pInfo = (SInfo *)userdefine;


	pInfo->m_counter++;
	pInfo->m_counter %= 10;

	switch (g_tableThreadState[pInfo->m_limit][pInfo->m_counter])
	{
	case -1:
		SuspendThread(pInfo->m_info.hThread);
		break;

	case 1:
		ResumeThread(pInfo->m_info.hThread);
	}
}
